# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: battle.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Team(betterproto.Message):
    users: List["_common__.UserId"] = betterproto.message_field(1)
    mons: List["_common__.MonId"] = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleState(betterproto.Message):
    active_battle: "ActiveBattle" = betterproto.message_field(1, group="state")
    end: "BattleEnded" = betterproto.message_field(2, group="state")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Battle(betterproto.Message):
    id: int = betterproto.int32_field(1)
    teams: List["Team"] = betterproto.message_field(2)
    state: "BattleState" = betterproto.message_field(3)
    last_update: datetime = betterproto.message_field(4)
    is_test: bool = betterproto.bool_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ActiveBattle(betterproto.Message):
    start_time: datetime = betterproto.message_field(1)
    turn_count: int = betterproto.int32_field(3)
    turn_queue: List["_common__.MonId"] = betterproto.message_field(4)
    # implies how much time there is for the next action
    last_action: datetime = betterproto.message_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Report(betterproto.Message):
    report: List[str] = betterproto.string_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class TurnQueueEvent(betterproto.Message):
    """whose turn is next?"""

    b: "Battle" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleStartedEvent(betterproto.Message):
    b: "Battle" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleEndedEvent(betterproto.Message):
    ev: "Report" = betterproto.message_field(1)
    winning_team: "Team" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleEvent(betterproto.Message):
    id: "_common__.BattleId" = betterproto.message_field(1)
    turn_update: "TurnQueueEvent" = betterproto.message_field(2, group="event")
    action: "ActionEvent" = betterproto.message_field(3, group="event")
    battle_started: "BattleStartedEvent" = betterproto.message_field(4, group="event")
    battle_ended: "BattleEndedEvent" = betterproto.message_field(5, group="event")
    battle_added: "BattleAdded" = betterproto.message_field(6, group="event")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleAdded(betterproto.Message):
    b: "Battle" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleEnded(betterproto.Message):
    ev: "Report" = betterproto.message_field(1)
    winning_team: "Team" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ActionEvent(betterproto.Message):
    source: "_common__.MonId" = betterproto.message_field(1)
    target: "_common__.MonId" = betterproto.message_field(2)
    effect: "_monster__.BattleValues" = betterproto.message_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleResponse(betterproto.Message):
    ev: "Report" = betterproto.message_field(1, group="message")
    turn_u: "TurnQueueEvent" = betterproto.message_field(3, group="message")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Command(betterproto.Message):
    battle_id: "_common__.BattleId" = betterproto.message_field(1)
    attack: "Attack" = betterproto.message_field(2, group="command")
    random: "RandomCommand" = betterproto.message_field(3, group="command")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleRequest(betterproto.Message):
    id: "_common__.BattleId" = betterproto.message_field(1)
    mon_ids: List["_common__.MonId"] = betterproto.message_field(2)
    user_id: "_common__.UserId" = betterproto.message_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleList(betterproto.Message):
    battles: List["Battle"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ResponseStatus(betterproto.Message):
    success: bool = betterproto.bool_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class RandomCommand(betterproto.Message):
    # sanity check
    source: "_common__.MonId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Attack(betterproto.Message):
    """later"""

    source: "_common__.MonId" = betterproto.message_field(1)
    target: "_common__.MonId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


class BattleServiceStub(betterproto.ServiceStub):
    async def add_battle(
        self,
        *,
        id: int = 0,
        teams: Optional[List["Team"]] = None,
        state: "BattleState" = None,
        last_update: datetime = None,
        is_test: bool = False,
    ) -> "_common__.BattleId":
        teams = teams or []

        request = Battle()
        request.id = id
        if teams is not None:
            request.teams = teams
        if state is not None:
            request.state = state
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test

        return await self._unary_unary(
            "/battle.BattleService/AddBattle", request, _common__.BattleId
        )

    async def get_battle_by_id(self, *, id: int = 0) -> "Battle":

        request = _common__.BattleId()
        request.id = id

        return await self._unary_unary(
            "/battle.BattleService/getBattleByID", request, Battle
        )

    async def get_battle_by_user_id(self, *, id: int = 0) -> "BattleList":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/battle.BattleService/GetBattleByUserID", request, BattleList
        )

    async def start_battle(
        self,
        *,
        id: "_common__.BattleId" = None,
        mon_ids: Optional[List["_common__.MonId"]] = None,
        user_id: "_common__.UserId" = None,
    ) -> "ResponseStatus":
        mon_ids = mon_ids or []

        request = BattleRequest()
        if id is not None:
            request.id = id
        if mon_ids is not None:
            request.mon_ids = mon_ids
        if user_id is not None:
            request.user_id = user_id

        return await self._unary_unary(
            "/battle.BattleService/StartBattle", request, ResponseStatus
        )

    async def add_test_battle(
        self,
        *,
        id: int = 0,
        teams: Optional[List["Team"]] = None,
        state: "BattleState" = None,
        last_update: datetime = None,
        is_test: bool = False,
    ) -> "_common__.BattleId":
        teams = teams or []

        request = Battle()
        request.id = id
        if teams is not None:
            request.teams = teams
        if state is not None:
            request.state = state
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test

        return await self._unary_unary(
            "/battle.BattleService/AddTestBattle", request, _common__.BattleId
        )

    async def command_request(
        self,
        *,
        battle_id: "_common__.BattleId" = None,
        attack: "Attack" = None,
        random: "RandomCommand" = None,
    ) -> "ResponseStatus":

        request = Command()
        if battle_id is not None:
            request.battle_id = battle_id
        if attack is not None:
            request.attack = attack
        if random is not None:
            request.random = random

        return await self._unary_unary(
            "/battle.BattleService/CommandRequest", request, ResponseStatus
        )


from .. import common as _common__
from .. import monster as _monster__
